import 'dart:convert';

import 'package:delivery_app/utils/g.dart' as g;

Autogenerated passengersDataFromJson(String str) => Autogenerated.fromJson(json.decode(str));

String passengersDataToJson(Autogenerated data) => json.encode(data.toJson());

class Autogenerated {
  late int currentPage;
  late List<Data> data;
  late String firstPageUrl;
  late int from;
  late int lastPage;
  late String lastPageUrl;
  late String nextPageUrl;
  late String path;
  late int perPage;
  late String prevPageUrl;
  late int to;
  late int total;

  Autogenerated(
      {
      required this.currentPage,
       required this.data,
       required this.firstPageUrl,
       required this.from,
       required this.lastPage,
       required this.lastPageUrl,
       required this.nextPageUrl,
       required this.path,
       required this.perPage,
       required this.prevPageUrl,
       required this.to,
       required this.total});

  Autogenerated.fromJson(Map<String, dynamic> json) {
    currentPage = json['current_page'];
    if (json['data'] != null) {
      data = <Data>[];
      json['data'].forEach((v) {
        data.add(Data.fromJson(v));
      });
    }
    firstPageUrl = json['first_page_url'];
    from = json['from'];
    lastPage = json['last_page'];
    lastPageUrl = json['last_page_url'];
    nextPageUrl = json['next_page_url'];
    path = json['path'];
    perPage = json['per_page'];
    prevPageUrl = json['prev_page_url'];
    to = json['to'];
    total = json['total'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['current_page'] = currentPage;
    if (this.data != null) {
      data['data'] = this.data.map((v) => v.toJson()).toList();
    }
    data['first_page_url'] = firstPageUrl;
    data['from'] = from;
    data['last_page'] = lastPage;
    data['last_page_url'] = lastPageUrl;
    data['next_page_url'] = nextPageUrl;
    data['path'] = path;
    data['per_page'] = perPage;
    data['prev_page_url'] = prevPageUrl;
    data['to'] = to;
    data['total'] = total;
    return data;
  }
}

class Data {
  late String driverId;
  late String customerId;
  late String customerName;
  late String customerAddress;
  late String customerPhone;
  late String sellOrderId;
  late String paymentStatus;
  late String createdAt;
  late  String totalPrice;
  late String shopName;
  late String shopPhone;
  late String shopAddress;
  late String status;
  late List<ProductDetail> productDetail;

  Data(
      {
       required this.driverId,
       required this.customerId,
       required this.customerName,
       required this.customerAddress,
       required  this.customerPhone,
       required  this.sellOrderId,
       required this.paymentStatus,
       required this.createdAt,
       required this.totalPrice,
       required  this.shopName,
       required this.shopPhone,
       required this.shopAddress,
       required  this.status,
       required  this.productDetail});

  Data.fromJson(Map<String, dynamic> json) {
    driverId = g.convertModelString(json['driver_id']);
    customerId = g.convertModelString(json['customer_id']);
    customerName = g.convertModelString(json['customer_name']);
    customerAddress = g.convertModelString(json['customer_address']);
    customerPhone = g.convertModelString(json['customer_phone']);
    sellOrderId = g.convertModelString(json['sell_order_id']);
    paymentStatus = g.convertModelString(json['payment_status']);
    createdAt = g.convertModelString(json['created_at']);
    totalPrice =g.convertModelString( json['total_price']);
    shopName = g.convertModelString(json['name']);
    shopPhone = g.convertModelString(json['shop_phone']);
    shopAddress = g.convertModelString(json['shop_address']);
    status = g.convertModelString(json['status']);
    if (json['product_detail'] != null) {
      productDetail = <ProductDetail>[];
      json['product_detail'].forEach((v) {
        productDetail.add(ProductDetail.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['driver_id'] = driverId;
    data['customer_id'] = customerId;
    data['customer_name'] = customerName;
    data['customer_address'] = customerAddress;
    data['customer_phone'] = customerPhone;
    data['sell_order_id'] = sellOrderId;
    data['payment_status'] = paymentStatus;
    data['created_at'] = createdAt;
    data['total_price'] = totalPrice;
    data['shop_name'] = shopName;
    data['shop_phone'] = shopPhone;
    data['shop_address'] = shopAddress;
    data['status'] = status;
    if (productDetail != null) {
      data['product_detail'] =
          productDetail.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class ProductDetail {
  late String sellOrderId;
  late String productName;
  late String size;
  late String items;
  late String sugar;
  late String cream;

  ProductDetail(
      {
       required this.sellOrderId,
       required this.productName,
       required this.size,
       required this.items,
       required this.sugar,
       required this.cream});

  ProductDetail.fromJson(Map<String, dynamic> json) {
    sellOrderId = g.convertModelString(json['sell_order_id']);
    productName = g.convertModelString(json['product_name']);
    size = g.convertModelString(json['size']);
    items = g.convertModelString(json['items']);
    sugar = g.convertModelString(json['sugar']);
    cream = g.convertModelString(json['cream']);
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['sell_order_id'] = sellOrderId;
    data['product_name'] = productName;
    data['size'] = size;
    data['items'] = items;
    data['sugar'] = sugar;
    data['cream'] = cream;
    return data;
  }
}
